import 'dart:io';

import 'package:ft/models/runtime_exception.dart';

Future<void> runAsync(String executable, List<String> arguments) async {
  var process = await Process.start(executable, arguments);
  await process.stdout.pipe(stdout);
  await process.stderr.pipe(stderr);
  if (await process.exitCode != 0) {
    stdout.write('An error happened while running the command.');
    throw RuntimeException(executable: executable, arguments: arguments);
  }
}

String? run(String executable, List<String> arguments) {
  var process = Process.runSync(executable, arguments);
  if (process.exitCode == 0) {
    return process.stdout;
  } else {
    throw RuntimeException(
        executable: executable,
        arguments: arguments,
        stderr: process.stderr.toString().isEmpty
            ? process.stdout
            : process.stderr);
  }
}
